\begin{multicols*}{2}
  \section{Solving Linear Equations}
In linear algebra we often encounter equations like the following
\begin{equation}
  Ax=b
\end{equation}
where $A$ is a known $m\times n$ matrix, $b$ is a known $n$-dimensional vector and $x$ is a unknown $m$-dimensional vector.

We call these equations linear equations and in this section we will discuss mutliple ways on how to solve these equations.
\\[6pt]
In general we want to know which linear combination of the vectors in $A$ will give us the vector $b$.
This linear combination is expressed in the vector $x$.
The solution $x$ must be a linear combination of the rowspace of $A$, thus when solving for $x$ we must preserve $R(A)$.
\subsection{Number of solutions and nullspace $N(A)$}
\paragraph{Overdetermined} If a matrix has more rows then columns, the matrix is overdetermined and probably has no solutions.
\paragraph{Underdetermined} If a matrix has less rows then columns, the matrix is underdetermined and has infinitly many solutions.
\subsubsection{Number of solutions}
\begin{center}
  \def\arraystretch{1.5}
  \begin{tabular}{c | c | c}
    & $r=n$ (full-column-rank) & $r<n$ dependent columns\\
    \hline
    $r=m$ (full-row-rank) & $1$ solution & $\infty$ solutions\\
    \hline
    $r<m$ (dependent rows) & $0$ or $1$ solutions\footnote{\label{note:number_of_solutions}depending on $b$} & $0$ or $\infty$ solutions\footref{note:number_of_solutions}
  \end{tabular}
\end{center}
\subsubsection{Nullspace $N(A)$}
The nullspace $N(A)$ is the vector space containing all the vectors which satisfy $Ax=0$.
\subsection{Row Echelon Form (ref)}
The row echelon form is a form of matrices that allows us to easily solve linear equations by back substitution.
The $i$-th row of such a matrix has atleast one more leading zero then the $(i-1)$-th row and the first non-zero entry is called called the i-th pivot.

\subsubsection{Gauss Elimination}
You can turn any matrix into the row echelon form by applying gauss elimination to it.


Gauss elimination only swaps rows and subtracts different non-zero multiples of rows to other rows.
This does not change the row space because, a span does not have a order and is still a span if we replace a vector with a non-zero linear combination of the basis.
%  TODO: write the gauss elimination algorithm
%  \begin{algorithm}
%    \caption{GaussElimination$(A)$}
%    \begin{algorithmic}
%      \State $P\leftarrow\begin{bmatrix}
%        1 & \cdots & 0\\
%        \vdots & \ddots & \vdots\\
%        0 & \cdots & 1
%      \end{bmatrix}$
%      \State $L\leftarrow\begin{bmatrix}
%        1 & 0 & \cdots & 0 & 0 \\
%        l_{21} & 1 & \cdots & 0 & 0 \\
%        \vdots & \vdots & \ddots &  & \vdots \\
%        l_{n-1,1} & l_{n-1,2} & \cdots & 1 & 0 \\
%        l_{n1} & l_{n2} & \cdots & l_{n,n-1} & 1 \\
%      \end{bmatrix}$
%      \State $U\leftarrow\begin{bmatrix}
%        u_{11}&\cdots&u_{1n}\\
%        \vdots & \ddots & \vdots\\
%        0 & \cdots & u_{nn}
%      \end{bmatrix}$
%      \For{$j=1,\dots,n-1$}
%        \State $u_i\leftarrow a_i$
%        \For{$i=j,\dots,n$}
%          \State $l_{ij}\leftarrow \frac{a_{i-1,j}}{a_{ij}}$
%          \State $a_{ik} \leftarrow a_{ik}\cdot(l_{ij}\cdot a_{i-1,k})\;\forall k \in \{j+1,\dots,n\}$
%          \If{$a_{i,j+1}=0$}
%            \State swap $p_i$ and $p_{j+1}$
%            \State swap $a_i$ and $a_{j+1}$
%            \State swap $l_i$ and $l_{j+1}$
%          \EndIf
%        \EndFor
%      \EndFor
%    \end{algorithmic}
%  \end{algorithm}
\subsubsection{$PA=LU$ factorization}
incase of a full rank $n\times n$ matrix we can factorize the $A$ matrix like the following
\begin{equation}
  PA=LU,\quad A=P^\top LU
\end{equation}
where $P$ is a permutation matrix, $L$ is a matrix where $L_{ij}$ is the number of times row $j$ was subtracted from row $i$ during gauss elimination and $U$ is the row echelon form of $A$.

This factorization is usefull because it allows us to solve the equation $Ax=b$ efficiantly for all $b$.
We only have to do forward substitution on
\[
  Lc=Pb
\]
And afterwards backwards substitution on
\[
  U(P^{-1}x)=c
\]

\subsection{Reduced Row Echelon Form (rref)}
The reduced row echelon form or rref is a matrix in ref, which only has $1$ as pivot elements and all entries above a pivot element are $0$.


One can turn any matrix into rref through further applying gauss elimination until you've achived rref.
\subsubsection{$A=CR$ factorization}
We can factorize any matrix like the following
\begin{equation}
  A=CR
\end{equation}
where $C$ is a $m\times r$ full-column-rank matrix containing the linear independent columns from $A$ and $R$ being the first $r$ rows of the rref of $A$.

This is useful in calculating the $N(A)$ since $N(A)=N(R)$.
\begin{equation}
  Rx=Iv+Fw=0 \quad\iff\quad v=-Fw
\end{equation}
where $v$ are the "free variables", I beeing the identity matrix and $F$ being the columns of $R$ that are not independent.
\begin{equation}
  C(A)=C(C)
\end{equation}
\subsection{Projection and Least Squares}
Sometimes if there is no solution to $Ax=b$ we might want to find the $\hat{x}$ in $A\hat{x}=b'$ where $b'$ is the closet point in $C(A)$ to $b$, i.e.
\begin{equation}
  b' = \text{proj}_{C(A)}(b) = \argmin_{b'\in C(A)}\lVert b-b' \rVert
\end{equation}
This $\hat{x}$ is defined as the following
\begin{equation}
  \min_{\hat{x}\in\mathbb{R}^n}\lVert A\hat{x}-b \rVert^2
\end{equation}
And we can solve for it using the following equation.
\begin{equation}
  A^\top A\hat{x}=A^\top b
\end{equation}
and whenever $A$ has independent columns $A^\top A$ is invertible and we can write
\begin{equation}
  \hat{x}=\left(A^\top A\right)^{-1}A^\top b
\end{equation}
To find the projection $b'$ we have to multiply $\hat{x}$ with another $A$, i.e.
\begin{equation}
  b'=A\hat{x}=A\left( A^\top A \right)^{-1}A^\top b = Pb
\end{equation}
where we call $P=A(A^\top A)^{-1}A^\top$ the projection matrix.
\paragraph{Linear regression}
\begin{equation}
  \begin{bmatrix}
    \alpha_0\\\alpha_1
  \end{bmatrix}
  =
  \begin{bmatrix}
    \frac1m\sum_{k=1}^m b_k\\\\
    \frac{\sum_{k=1}^mt_kb_k}{\sum_{k=1}^mt_k^2}
  \end{bmatrix}
\end{equation}
\subsection{$A=QR$ factorization}
We can factorize any matrix like the following
\begin{equation}
  A=QR
\end{equation}
where $Q$ is an $m\times n$ orthogonal matrix, and $R$ s an upper triangular matrix given by $R=Q^\top A$.

This decomposition greatly simplifies calculations involving projections and least squares.
It allows you to write the following instead of $A^\top A\widehat{x}=A^\top b$,
\begin{equation}
  R\hat{x}=Q^\top b
\end{equation}
\subsection{Pseudoinverse $A^\dag$}
The goal of the pseudoinverse is to be an analogue to he inverse of a matrix $A$ for matrices that have no inverse.
\paragraph{Pseudoinverse for matrices $A$ with $\rank(A)=n$}
\begin{equation}
  A^\dag = (A^\top A)^{-1}A^\top
\end{equation}
This is a left inverse of $A$
\paragraph{Pseudoinverse for matrices $A$ with $\rank(A)=m$}
\begin{equation}
  A^\dag = A^\top (AA^\top)^{-1}
\end{equation}
This is a right inverse of $A$
\paragraph{Pseudoinverse for arbitrary matrices $A=CR$}
\begin{equation}
  A^\dag = R^\dag C^\dag = R^\top(RR^\top)^{-1}(C^\top C)^{-1}C^\top
\end{equation}
where $C^\dag$ is a left inverse and $R^\dag$ is a right inverse.


\end{multicols*}